# DSL program describing the state machine using nested code blocks

initfsm do |fsm| 
  fsm.alarm = false
  fsm.credit = 0
end

state 'locked'
state 'unlocked'
state 'violation'

transition "charging" do |t|
  t.from_state 'locked'
  t.to_state 'locked'
  t.event = 'coin'
  t.guard do |credit|
    if (credit + 1) < 3
      true
    end
  end
  t.action do |fsm|
   fsm.credit += 1
  end
end

transition "unlocking" do |t|
  t.from_state 'locked'
  t.to_state 'unlocked'
  t.event = 'coin'
  t.guard do |credit|
    if (credit + 1) == 3
      true
    end
  end
  t.action do |fsm|
   fsm.credit = 0
  end
end

transition "locking" do |t|
  t.from_state 'unlocked'
  t.to_state 'locked'
  t.event = 'doorClose'
end

transition "violation" do |t|
  t.from_state 'locked'
  t.to_state 'violation'
  t.event = 'doorOpen'
  t.action do |fsm|
   fsm.alarm = 1
  end
end

transition "resetting" do |t|
  t.from_state 'violation'
  t.to_state 'locked'
  t.event = 'reset'
  t.action do |fsm|
   fsm.alarm = false
   fsm.credit = 0
  end
end
