# This class captures the information associated with the 
# Turstile state machine

require 'transition_class'

class Fsm

attr_accessor :states, :transitions, :c_state, :alarm, :credit

def initialize
  @states = Array.new
  @transitions = Array.new
  @alarm = false
  @credit = 0
end

def initfsm
  yield self
end

def state(state)
  @states.push(state)
end

def transition(name, &block)
 _transition = Transition_class.new(name)
 _transition.load_block(&block)
 @transitions.push(_transition)
end

def load(fsm_dsl)
  instance_eval(File.read(fsm_dsl),fsm_dsl)
  @c_state = @states[0]
  puts "Current State of FSM : #{@c_state} "
  puts "alarm : #{@alarm} "
  puts "credit : #{@credit} "
end

def to_s
  "fsm :: alarm : #{@alarm} , credit : #{@credit}, state : #{@c_state} "
end
end
