# This is the main program which accepts fsm.dsl and simple.fsm as parameters

require 'fsm'

# fsm.dsl (first parameter) is loaded and evaluated for an 'Fsm' object
if ARGV[0] != nil
   puts "loading fsm DSL : #{ARGV[0]} "
   @fsm = Fsm.new
   @fsm.load(ARGV[0])
else
   raise ArgumentError.new("Please provide a DSL for fsm")
end

# This method processes the event that is read from 'simple.fsm' 
def event(_event)
      puts " \nEVENT : #{_event} "
      @fsm.transitions.each do |i| 
        puts "TRANSITION : #{i.name}"
        if i.get_from_state == @fsm.c_state
          if i.get_event == _event
             puts " #  STATE : #{i.get_from_state} , EVENT : #{_event} -- match found. invoke guard "
             _guard = i.call_guard(@fsm.alarm, @fsm.credit)
             if _guard == true
               puts "  guard is true. lets run the action items.."
               @fsm.c_state = i.get_to_state
               i.call_action(@fsm)
               puts "  Actions performed. \n" + @fsm.to_s
              return 
             end
          end
        end
      end
      puts @fsm.to_s
end

if ARGV[1] != nil
   puts "loading events : #{ARGV[1]} "
   load ARGV[1]
else
   raise ArgumentError.new("Please provide a file with list of events.")
end

